#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'colours/autoinclude'
require 'bioroebe'

target_file = Bioroebe.project_base_dir?+'data/pdb/rcsb_pdb_1VII.fasta'
target_pdb_file = Bioroebe.project_base_dir?+'data/pdb/1VII.pdb'
sequence1 = Bioroebe.return_aminoacid_sequence_from_this_pdb_file(target_pdb_file)

# =========================================================================== #
# The sequence1 should be: 'MLSDEDFKAVFGMTRSAFANLPLWKQQNLKKEKGLF'
# =========================================================================== #
if sequence1 == File.readlines(target_file).last.strip
  e Colours.rev+"All is fine - we compared the two sequences."
  e Colours.rev+'The sequence is:'
  e steelblue(sequence1)
else
  e swarn('Test comparison failed!')
  pp sequence1
  pp File.readlines(target_file).last.strip
end