#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# This simple test will take a given DNA as input, and output the reverse
# complement to the given DNA strand at hand.
#
# The simple rules are that A pairs with T and C pairs with G.
#
# The reverse complement of a DNA string s is the string reverse_s
# formed by reversing the elements of string s, then taking the
# complement of each element. For example, the reverse complement
# of "GTCA" is "TGAC"
# =========================================================================== #
require 'bioroebe/sequence/reverse_complement.rb'

alias e puts

if ARGV.empty?
  sample = 'AAAACCCGGT'
else
  sample = ARGV.first
end

# =========================================================================== #
# Expected output:
#   ACCGGGTTTT
# =========================================================================== #
# Note that this will output the correct answer as-is.
# =========================================================================== #
e 'The sequence '+sample+' is reversed:'
e '             '+Bioroebe::ReverseComplement[sample]
