#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'bioroebe'
require 'colours/everything/autoinclude'

require 'optparse'
options = {}
optparse = OptionParser.new {|opts|
  opts.on( '-j', '--json_file FILE', ' The name of JSON config file' ) { |j|
    options[:json] = j
  }
  opts.on( '-o', '--svg_file FILE', ' The name of the SVG output-file' ) { |s|
    options[:svg] = s
  }
  # This displays the help screen, all programs are assumed
  # to have this option.
  opts.on( '-h', '--help', 'Display this screen' ) {
    puts opts
    exit
  }
}
optparse.parse! # Parse ARGV here.
# =========================================================================== #
# Feed into Bioroebe::SVG::Page.from_json() here.
# The test/ directory comes with a bundled .json file as example,
# called 'example_config.json'.
# Keep in mind that this example .json file has a hardcoded file
# name to the .gff file.
# =========================================================================== #
Bioroebe::SVG::Page.from_json(
  :json => options[:json], :outfile => options[:svg]
) # rb testing_svg_component_of_bioroebe_from_json_dataset.rb --json_file example_config.json --svg_file generated_from_json_dataset.svg